'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var utils = require('./utils.js');

const TemplateCache = function() {
  var cache = {};
  return {
    load: function(url, serviceUrl, client) {
      var p = cache[url];
      if (!p) {
        cache[url] = p = client.get(url).then(function(html) {
          var templates = {};
          var styleSheets = [];
          var baseUri = utils.rTrim(serviceUrl, "\\/") + "/";
          html = utils.replaceAll(html, "{service}/", baseUri);
          html = utils.replaceAll(html, "{service}", baseUri);
          var viewerTemplate = $("<div></div>").html(html);
          utils.each(viewerTemplate.find("template"), function(index, e) {
            var $e = $(e);
            templates[$e.attr("id")] = utils.trim($e.html(), "\n 	");
          });
          utils.each(viewerTemplate.find("link"), function(index, e) {
            styleSheets.push(utils.trim(e.outerHTML, "\n 	"));
          });
          styleSheets = utils.filterUniqueLastOccurance(styleSheets);
          return {
            templates,
            styleSheets
          };
        });
      }
      return p;
    }
  };
}();

exports.TemplateCache = TemplateCache;
