import { rTrim, replaceAll, each, trim, filterUniqueLastOccurance } from './utils.js';

const TemplateCache = function() {
  var cache = {};
  return {
    load: function(url, serviceUrl, client) {
      var p = cache[url];
      if (!p) {
        cache[url] = p = client.get(url).then(function(html) {
          var templates = {};
          var styleSheets = [];
          var baseUri = rTrim(serviceUrl, "\\/") + "/";
          html = replaceAll(html, "{service}/", baseUri);
          html = replaceAll(html, "{service}", baseUri);
          var viewerTemplate = $("<div></div>").html(html);
          each(viewerTemplate.find("template"), function(index, e) {
            var $e = $(e);
            templates[$e.attr("id")] = trim($e.html(), "\n 	");
          });
          each(viewerTemplate.find("link"), function(index, e) {
            styleSheets.push(trim(e.outerHTML, "\n 	"));
          });
          styleSheets = filterUniqueLastOccurance(styleSheets);
          return {
            templates,
            styleSheets
          };
        });
      }
      return p;
    }
  };
}();

export { TemplateCache };
